<template>
  <v-container v-if="flight" class="pa-0">
    <FlightsFlightHeader :flight="flight" />
    <v-container class="pa-0" :style="{ 'margin-top': '76px' }">
      <NuxtPage :flight="flight" />
    </v-container>
    <FlightsFlightDocuments :flight="flight" />
  </v-container>
  <FlightsFlightSkeletonLoader v-else-if="loading" />
</template>

<script setup lang="ts">

definePageMeta({
  layout: 'airvam',
  middleware: ['redirect-flight'],
})

import { Flight } from "~/dto/flight.dto";
import { Leg } from "~/dto/leg.dto";

const route = useRoute();

const id: Ref<string | null> = ref(null);
const flight: Ref<Flight | null> = ref(null);
const loading = ref(false);

const { $api, $toast } = useNuxtApp();

onMounted(async () => {
  id.value = route.params.id === 'nouveau' ? null : route.params.id as string;
  if (id.value) {
    loading.value = true;
    try {
      const flightTmp: Flight = await $api.flightPaginated.get(id.value);
      flightTmp.legs.map((l: Leg) => {
        l.departureTime = l.departureTime ? new Date(l.departureTime) : null;
        return l;
      });
      flight.value = flightTmp;
    } catch (e) {
      console.log(e)
      $toast.error(`Erreur lors du chargement du listing de vols`);
    }
    loading.value = false;
  } else {
    flight.value = new Flight();
  }
})
</script>
